Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.s9api
Class Processor

    java.lang.Object
      net.sf.saxon.s9api.Processor

    public class Processor

extends java.lang.Object

The `Processor` class serves three purposes: it allows global Saxon configuration options to be set; it acts as a factory for generating XQuery, XPath, and XSLT compilers; and it owns certain shared resources such as the Saxon NamePool and compiled schemas. This is the first object that a Saxon application should create. Once established, a Processor may be used in multiple threads.

It is possible to run more than one Saxon Processor concurrently, but only when running completely independent workloads. Nothing can be shared between Processor instances. Within a query or transformation, all source documents and schemas must be built using the same Processor, which must also be used to compile the query or stylesheet.

Constructor Summary
`Processor(boolean schemaAware)` Create a Processor

Method Summary
`java.lang.Object` | `getConfigurationProperty(java.lang.String name)` Get the value of a configuration property
`java.lang.String` | `getSaxonProductVersion()` Get the user-visible Saxon product version, for example "9.0.0.1"
`SchemaManager` | `getSchemaManager()` Get the associated SchemaManager.
`Configuration` | `getUnderlyingConfiguration()` Get the underlying `Configuration` object that underpins this Processor.
`java.lang.String` | `getXmlVersion()` Get the version of XML used by this Processor.
`boolean` | `isSchemaAware()` Test whether this processor is schema-aware
`DocumentBuilder` | `newDocumentBuilder()` Create a DocumentBuilder.
`XPathCompiler` | `newXPathCompiler()` Create an XPathCompiler.
`XQueryCompiler` | `newXQueryCompiler()` Create an XQueryCompiler.
`XsltCompiler` | `newXsltCompiler()` Create an XsltCompiler.
`void` | `setConfigurationProperty(java.lang.String name, java.lang.Object value)` Set a configuration property
`void` | `setXmlVersion(java.lang.String version)` Set the version of XML used by this Processor.
`void` | `writeXdmValue(XdmValue value, Destination destination)` Write an XdmValue to a given destination.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Processor

    public Processor(boolean schemaAware)

  Create a Processor

  Parameters:
    `schemaAware` - indicates whether the Processor is schema-aware or not. To create a schema-aware processor, the Saxon-SA product is required. This flag should be set if any Saxon-SA specific functionality or optimization is required, whether or not schemas are used.

Method Detail

### newDocumentBuilder

    public DocumentBuilder newDocumentBuilder()

  Create a DocumentBuilder. A DocumentBuilder is used to load source XML documents.

  Returns:
    a newly created DocumentBuilder

### newXPathCompiler

    public XPathCompiler newXPathCompiler()

  Create an XPathCompiler. An XPathCompiler is used to compile XPath expressions.

  Returns:
    a newly created XPathCompiler

### newXsltCompiler

    public XsltCompiler newXsltCompiler()

  Create an XsltCompiler. An XsltCompiler is used to compile XSLT stylesheets.

  Returns:
    a newly created XsltCompiler
  Throws:
    `java.lang.UnsupportedOperationException` - if this version of the Saxon product does not support XSLT processing

### newXQueryCompiler

    public XQueryCompiler newXQueryCompiler()

  Create an XQueryCompiler. An XQueryCompiler is used to compile XQuery queries.

  Returns:
    a newly created XQueryCompiler
  Throws:
    `java.lang.UnsupportedOperationException` - if this version of the Saxon product does not support XQuery processing

### getSchemaManager

    public SchemaManager getSchemaManager()

  Get the associated SchemaManager. The SchemaManager provides capabilities to load and cache XML schema definitions. There is exactly one SchemaManager in a schema-aware Processor, and none in a Processor that is not schema-aware. The SchemaManager is created automatically by the system.

  Returns:
    the associated SchemaManager, or null if the Processor is not schema-aware.

### isSchemaAware

    public boolean isSchemaAware()

  Test whether this processor is schema-aware

  Returns:
    true if this is a schema-aware processor, false otherwise

### getSaxonProductVersion

    public java.lang.String getSaxonProductVersion()

  Get the user-visible Saxon product version, for example "9.0.0.1"

  Returns:
    the Saxon product version, as a string

### setXmlVersion

    public void setXmlVersion(java.lang.String version)

  Set the version of XML used by this Processor. If the value is set to "1.0", then output documents will be serialized as XML 1.0. This option also affects the characters permitted to appear in queries and stylesheets, and the characters that can appear in names (for example, in path expressions).

  Note that source documents specifying xml version="1.0" or "1.1" are accepted regardless of this setting.

  Parameters:
    `version` - must be one of the strings "1.0" or "1.1"
  Throws:
    `java.lang.IllegalArgumentException` - if any string other than "1.0" or "1.1" is supplied

### getXmlVersion

    public java.lang.String getXmlVersion()

  Get the version of XML used by this Processor. If the value is "1.0", then input documents must be XML 1.0 documents, and output documents will be serialized as XML 1.0. This option also affects the characters permitted to appear in queries and stylesheets, and the characters that can appear in names (for example, in path expressions).

  Returns:
    one of the strings "1.0" or "1.1"

### setConfigurationProperty

    public void setConfigurationProperty(java.lang.String name,
                                         java.lang.Object value)

  Set a configuration property

  Parameters:
    `name` - the name of the option to be set. The names of the options available are listed as constants in class `FeatureKeys`.
    `value` - the value of the option to be set.
  Throws:
    `java.lang.IllegalArgumentException` - if the property name is not recognized

### getConfigurationProperty

    public java.lang.Object getConfigurationProperty(java.lang.String name)

  Get the value of a configuration property

  Parameters:
    `name` - the name of the option required. The names of the properties available are listed as constants in class `FeatureKeys`.
  Returns:
    the value of the property, if one is set; or null if the property is unset and there is no default.
  Throws:
    `java.lang.IllegalArgumentException` - if the property name is not recognized

### getUnderlyingConfiguration

    public Configuration getUnderlyingConfiguration()

  Get the underlying `Configuration` object that underpins this Processor. This method provides an escape hatch to internal Saxon implementation objects that offer a finer and lower-level degree of control than the s9api classes and methods. Some of these classes and methods may change from release to release.

  Returns:
    the underlying Configuration object

### writeXdmValue

    public void writeXdmValue(XdmValue value,
                              Destination destination)
                       throws SaxonApiException

  Write an XdmValue to a given destination. The sequence represented by the XdmValue is "normalized" as defined in the serialization specification (this is equivalent to constructing a document node in XSLT or XQuery with this sequence as the content expression), and the resulting document is then copied to the destination. If the destination is a serializer this has the effect of serializing the sequence as described in the W3C specifications.

  Parameters:
    `value` - the value to be written
    `destination` - the destination to which the value is to be written
  Throws:
    `SaxonApiException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) Saxonica Limited. All rights reserved.